config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :quizzes
  resources :questions
  resources :quiz_sessions do
    resources :steps, controller: 'quiz_sessions/steps'
  end
  resources :users

  get "up" => "rails/health#show", as: :rails_health_check

  root "quizzes#index"
end

app/models/quiz_session.rb
class QuizSession < ApplicationRecord
  belongs_to :user

  scope :for_user, -> (user) { where(user: user) } 
end

app/models/quiz_sessions.rb
module QuizSessions
  def self.table_name_prefix
    "quiz_sessions_"
  end
end

app/controllers/quiz_sessions/steps_controller.rb
class QuizSessions::StepsController < ApplicationController
  # GET /quiz_sessions/steps/1/edit
  def edit
    @result = QuizSession::Actions::GetStep.call(quiz_session_id: params[:quiz_session_id], user: current_user, step: params[:id])

    respond_to do |format|
      if @result[:success]
        next_step = @result[:success][:next_step]
        redirect_path = next_step ? edit_quiz_session_step_path(quiz_session_id: params[:quiz_session_id], id: next_step) : quiz_session_path(params[:quiz_session_id])

        format.html { redirect_to redirect_path }
        format.json { render :show, status: :ok, location: @quiz_session_step }
      elsif @result[:failure]
        format.html { redirect_to quiz_sessions_path, error: @result[:failure] }
        format.json { render json: @quiz_session_step.errors, status: :unprocessable_entity }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz_session_step.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /quiz_sessions/steps/1 or /quiz_sessions/steps/1.json
  def update
    @result = QuizSession::Actions::UpsertAnswer.call(
      quiz_session_id: params[:quiz_session_id],
      step: params[:id].to_i,
      user: current_user,
      answer: params.require(:answer).permit!
    )

    respond_to do |format|
      if @result[:success]
        next_step = @result[:success][:next_step]
        redirect_path = next_step ? edit_quiz_session_step_path(quiz_session_id: params[:quiz_session_id], id: next_step) : quiz_session_path(params[:quiz_session_id])

        format.html { redirect_to redirect_path }
        format.json { render :show, status: :ok, location: @quiz_session_step }
      elsif @result[:failure]
        format.html { render edit_quiz_session_step_path(quiz_session_id: params[:quiz_session_id], id: next_step), status: @result[:failure][:status], errors: @result[:success] }
        format.json { render json: @quiz_session_step.errors, status: :unprocessable_entity }
      else
        format.html { render :edit, status: :unprocessable_entity, errors: @result[:failure] }
        format.json { render json: @quiz_session_step.errors, status: :unprocessable_entity }
      end
    end
  end
end

app/controllers/quiz_sessions_controller.rb
class QuizSessionsController < ApplicationController
  before_action :set_quiz_session, only: %i[ show edit destroy ]

  # GET /quiz_sessions or /quiz_sessions.json
  def index
    @quiz_sessions = QuizSession.for_user(current_user)
  end

  # GET /quiz_sessions/1 or /quiz_sessions/1.json
  def show
    respond_to do |format|
      if @quiz_session
        format.html
        format.json { render :show, status: :ok, location: @quiz_session }
      else
        format.html { redirect_to quiz_sessions_path, error: "Resource not Found" }
        format.json { render json: @quiz_session_step.errors, status: :unprocessable_entity }
      end
    end
  end

  # POST /quiz_sessions or /quiz_sessions.json
  def create
    @quiz_session = QuizSession::Actions::CreateQuizSessionFromQuiz.call(
      quiz_id: quiz_session_params[:quiz_id],
      user: current_user
    )

    respond_to do |format|
      if @quiz_session.save
        format.html { redirect_to edit_quiz_session_step_url(quiz_session_id: @quiz_session.id, id: 1) }
        format.json { render :show, status: :created, location: @quiz_session }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quiz_session.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quiz_sessions/1 or /quiz_sessions/1.json
  def destroy
    @quiz_session.destroy!

    respond_to do |format|
      format.html { redirect_to quiz_sessions_url, notice: "Quiz session was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_quiz_session
      @quiz_session = QuizSession.for_user(current_user).find_by(id: params[:id])
    end

    # Only allow a list of trusted parameters through.
    def quiz_session_params
      params.require(:quiz_session).permit(:quiz_id)
    end
end

app/helpers/quiz_sessions/step_helper.rb
module QuizSessions::StepHelper
end

app/helpers/quiz_sessions/steps_helper.rb
module QuizSessions::StepsHelper
end

app/helpers/quiz_sessions_helper.rb
module QuizSessionsHelper
end

app/views/quiz_sessions/steps/_form.html.erb
<%= form_with(url: quiz_session_step_path(quiz_session_id: params[:quiz_session_id], id: params[:id]), method: :patch) do |form| %>
  <% if quiz_sessions_step&.dig(:failure, :errors)&.any? %>
    <div style="color: red">
      <h2><%= pluralize(quiz_sessions_step.dig(:failure, :errors).count, "error") %> prohibited this step from being saved:</h2>

      <ul>
        <% quiz_sessions_step.dig(:failure, :errors).each do |error| %>
          <li><%= error %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <h2><%= quiz_sessions_step["statement"] %></h2>

  <%= hidden_field(:answer, :question, :value => quiz_sessions_step['question_identifier']) %>
  
  <% quiz_sessions_step.dig("config", "alternatives").each do |a| %>
    <div>
      <%= radio_button :answer, :alternative, a["identifier"], checked: quiz_sessions_step.dig(:answer, 'alternative') == a["identifier"] %>
      <%= label :answer, "alternative_#{a["identifier"]}", a["text"] %>
    </div>
  <% end %>

  <br>

  <div>
    <%= link_to("Back", quiz_session_step_path(quiz_session_id: params[:quiz_session_id], id: quiz_sessions_step[:previous_step])) if quiz_sessions_step[:previous_step] %>
    <%= form.submit(quiz_sessions_step[:last_step] ? "Finish" : "Submit") %>
  </div>
<% end %>

app/views/quiz_sessions/steps/_step.html.erb
<div id="<%= dom_id step %>">
</div>

app/views/quiz_sessions/steps/edit.html.erb
<h1><%= @result.dig("quiz_config", "title") %></h1>

<%= render "form", quiz_sessions_step: @result %>

<br>

<div>
  <%= link_to "Back to all Quizzes", quiz_path %>
</div>

app/views/quiz_sessions/steps/index.html.erb
<p style="color: green"><%= notice %></p>
<p style="color: red"><%= error %></p>

<h1>Steps</h1>

<div id="quiz_sessions_steps">
  <% @quiz_sessions_steps.each do |quiz_sessions_step| %>
    <%= render quiz_sessions_step %>
    <p>
      <%= link_to "Show this step", quiz_sessions_step %>
    </p>
  <% end %>
</div>

<%= link_to "New step", new_quiz_sessions_step_path %>

app/views/quiz_sessions/steps/new.html.erb
<h1>New step</h1>

<%= render "form", quiz_sessions_step: @quiz_sessions_step %>

<br>

<div>
  <%= link_to "Back to steps", quiz_sessions_steps_path %>
</div>

app/views/quiz_sessions/steps/show.html.erb
<p style="color: green"><%= notice %></p>
<p style="color: red"><%= error %></p>

<%= render @quiz_sessions_step %>

<div>
  <%= link_to "Edit this step", edit_quiz_sessions_step_path(@quiz_sessions_step) %> |
  <%= link_to "Back to steps", quiz_sessions_steps_path %>

  <%= button_to "Destroy this step", @quiz_sessions_step, method: :delete %>
</div>